function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable @typescript-eslint/no-var-requires */

/* eslint-disable @typescript-eslint/no-require-imports */
// eslint-disable-next-line filenames/match-exported
import { createPlugin } from '@modern-js/runtime-core';
import React, { useContext } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
export var DesignTokenContext = /*#__PURE__*/React.createContext({});
export var useDesignTokens = function useDesignTokens() {
  return useContext(DesignTokenContext);
};

var designToken = function designToken() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return createPlugin(function () {
    return {
      hoc: function hoc(_ref, next) {
        var _App = _ref.App;
        return next({
          App: function App(props) {
            var _options$token = options.token,
                token = _options$token === void 0 ? {} : _options$token,
                _options$useStyledCom = options.useStyledComponentsThemeProvider,
                useStyledComponentsThemeProvider = _options$useStyledCom === void 0 ? false : _options$useStyledCom,
                _options$useDesignTok = options.useDesignTokenContext,
                useDesignTokenContext = _options$useDesignTok === void 0 ? false : _options$useDesignTok;

            if (useStyledComponentsThemeProvider && useDesignTokenContext) {
              var _require = require('@modern-js/runtime-core/styled'),
                  ThemeProvider = _require.ThemeProvider;

              return /*#__PURE__*/_jsx(ThemeProvider, {
                theme: token,
                children: /*#__PURE__*/_jsx(DesignTokenContext.Provider, {
                  value: token,
                  children: /*#__PURE__*/_jsx(_App, _objectSpread({}, props))
                })
              });
            } else if (useStyledComponentsThemeProvider) {
              var _require2 = require('@modern-js/runtime-core/styled'),
                  _ThemeProvider = _require2.ThemeProvider;

              return /*#__PURE__*/_jsx(_ThemeProvider, {
                theme: token,
                children: /*#__PURE__*/_jsx(_App, _objectSpread({}, props))
              });
            } else if (useDesignTokenContext) {
              return /*#__PURE__*/_jsx(DesignTokenContext.Provider, {
                value: token,
                children: /*#__PURE__*/_jsx(_App, _objectSpread({}, props))
              });
            } else {
              return /*#__PURE__*/_jsx(_App, _objectSpread({}, props));
            }
          }
        });
      }
    };
  }, {
    name: '@modern-js/plugin-design-token'
  });
};

export default designToken;
/* eslint-enable @typescript-eslint/no-require-imports */

/* eslint-enable @typescript-eslint/no-var-requires */